# -*- coding: utf-8 -*-
from setuphelpers import *

current_lang = get_language()
winscp_path = makepath(programfiles32, "WinSCP")

winscp_ini = rf"""[Setup]
Lang={current_lang}
Dir={winscp_path}
Group=WinSCP
NoIcons=0
SetupType=full
Components=main,shellext,pageant,puttygen,transl,transl\eng,transl\fr
Tasks=desktopicon,desktopicon\user,sendtohook,urlhandler
[Configuration\Interface\Updates]
Period=0"""

app_uninstallstring = makepath(winscp_path, "unins000.exe")
app_uninstallkey = "winscp3_is1"

def install():
    # Adapting the configuration file depending on running system
    open("winscp.ini", "w").write(winscp_ini)

    uninstall_msi_version()

    # Installing the package
    install_exe_if_needed(
        f"WinSCP-{control.get_software_version()}-Setup.exe",
        silentflags="/VERYSILENT /SUPPRESSMSGBOXES /NORESTART /LOADINF=winscp.ini",
        key="winscp3_is1",
        min_version=control.get_software_version(),
    )

    # Adding QuietUninstallString
    quiet_uninstall_string = rf'"{app_uninstallstring}" /SILENT /NORESTART'
    register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)
    

def uninstall_msi_version():

    killalltasks(ensure_list(control.impacted_process))

    for to_uninstall  in installed_softwares(control.name):
        uninstall_command = uninstall_cmd(to_uninstall['key'])
        if 'msiexec' in uninstall_command.lower():  # Verify if it's an MSI installation
            print("MSI version of WinSCP found: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            run(uninstall_command)
            wait_uninstallkey_absent(to_uninstall["key"])